Index: trunk/openjdk/Makefile
===================================================================
--- trunk/openjdk/Makefile	(revision 309)
+++ trunk/openjdk/Makefile	(revision 310)
@@ -332,5 +332,7 @@
 MSDEVTOOLS_PATH.desc       = Root directory of VC++ tools (e.g. rc.exe)
 MSVCRT_DLL_PATH.desc       = Directory containing mscvrt.dll
-ODINSDK_PATH.desc          = Root directory of Odin32 SDK (OS/2)
+ODINSDK_HEADERS_PATH.desc  = Include directory of Odin32 SDK (OS/2)
+ODINSDK_LIB_PATH.desc      = Library directory of Odin32 SDK (OS/2)
+ODINSDK_DBGLIB_PATH.desc   = Debug Library directory of Odin32 SDK (OS/2, optional)
 
 # Make variables to print out (description and value)
@@ -376,8 +378,10 @@
 
 VARIABLE_PRINTVAL_LIST +=       \
-    ODINSDK_PATH
+    ODINSDK_HEADERS_PATH        \
+    ODINSDK_LIB_PATH
 
 VARIABLE_CHECKDIR_LIST +=       \
-    ODINSDK_PATH
+    ODINSDK_HEADERS_PATH        \
+    ODINSDK_LIB_PATH
 
 endif
Index: trunk/openjdk/corba/make/common/Defs-os2.gmk
===================================================================
--- trunk/openjdk/corba/make/common/Defs-os2.gmk	(revision 309)
+++ trunk/openjdk/corba/make/common/Defs-os2.gmk	(revision 310)
@@ -164,12 +164,11 @@
                    -D_POSIX_C_SOURCE=200112 -D_EMX_SOURCE -D_XOPEN_SOURCE=600 \
 				   -D_SVID_SOURCE
-CPPFLAGS_COMMON += -I$(ODINSDK_PATH)/include/Win -I$(ODINSDK_PATH)/include \
+CPPFLAGS_COMMON += -I$(ODINSDK_HEADERS_PATH)/Win -I$(ODINSDK_HEADERS_PATH) \
                    -DWINE_LARGE_INTEGER
 
-LDFLAGS_OPT     += -L$(ODINSDK_PATH)/lib/Release -L$(ODINSDK_PATH)/lib
-LDFLAGS_DBG     += -L$(ODINSDK_PATH)/lib/Debug -L$(ODINSDK_PATH)/lib
+LDFLAGS_OPT     += -L$(ODINSDK_LIB_PATH)
+LDFLAGS_DBG     += -L$(firstword $(ODINSDK_DBGLIB_PATH) $(ODINSDK_LIB_PATH))
 LDFLAGS_COMMON  += -lkernel32.lib -luser32.lib -ladvapi32.lib \
-				   -lminivcrt.lib -lntdll.lib \
-				   -llibwrap0.lib -llibwrap1.lib
+				   -lminivcrt.lib -lntdll.lib -llibwrap.lib
 
 #
Index: trunk/openjdk/corba/make/common/shared/Defs-os2.gmk
===================================================================
--- trunk/openjdk/corba/make/common/shared/Defs-os2.gmk	(revision 309)
+++ trunk/openjdk/corba/make/common/shared/Defs-os2.gmk	(revision 310)
@@ -142,11 +142,27 @@
 endif
 
-# ODINSDK_PATH: Path to the root directory of Odin32 SDK
-ifdef ALT_ODINSDK_PATH
-  xALT_ODINSDK_PATH :="$(subst \,/,$(ALT_ODINSDK_PATH))"
-  ODINSDK_PATH      :=$(call FullPath,$(xALT_ODINSDK_PATH))
+# ODINSDK_HEADERS_PATH: Include directory of Odin32 SDK (OS/2)
+ifdef ALT_ODINSDK_HEADERS_PATH
+  xALT_ODINSDK_HEADERS_PATH :="$(subst \,/,$(ALT_ODINSDK_HEADERS_PATH))"
+  ODINSDK_HEADERS_PATH      :=$(call FullPath,$(xALT_ODINSDK_HEADERS_PATH))
 endif
-ODINSDK_PATH :=$(call AltCheckSpaces,ODINSDK_PATH)
-ODINSDK_PATH :=$(call AltCheckValue,ODINSDK_PATH)
+ODINSDK_HEADERS_PATH :=$(call AltCheckSpaces,ODINSDK_HEADERS_PATH)
+ODINSDK_HEADERS_PATH :=$(call AltCheckValue,ODINSDK_HEADERS_PATH)
+
+# ODINSDK_LIB_PATH: Library directory of Odin32 SDK (OS/2)
+ifdef ALT_ODINSDK_LIB_PATH
+  xALT_ODINSDK_LIB_PATH :="$(subst \,/,$(ALT_ODINSDK_LIB_PATH))"
+  ODINSDK_LIB_PATH      :=$(call FullPath,$(xALT_ODINSDK_LIB_PATH))
+endif
+ODINSDK_LIB_PATH :=$(call AltCheckSpaces,ODINSDK_LIB_PATH)
+ODINSDK_LIB_PATH :=$(call AltCheckValue,ODINSDK_LIB_PATH)
+
+# ODINSDK_DBGLIB_PATH: Debug Library directory of Odin32 SDK (OS/2)
+ifdef ALT_ODINSDK_DBGLIB_PATH
+  xALT_ODINSDK_DBGLIB_PATH :="$(subst \,/,$(ALT_ODINSDK_DBGLIB_PATH))"
+  ODINSDK_DBGLIB_PATH      :=$(call FullPath,$(xALT_ODINSDK_DBGLIB_PATH))
+endif
+ODINSDK_DBGLIB_PATH :=$(call AltCheckSpaces,ODINSDK_DBGLIB_PATH)
+ODINSDK_DBGLIB_PATH :=$(call AltCheckValue,ODINSDK_DBGLIB_PATH)
 
 # Import JDK images allow for partial builds, components not built are
Index: trunk/openjdk/hotspot/make/os2/makefiles/compile.make
===================================================================
--- trunk/openjdk/hotspot/make/os2/makefiles/compile.make	(revision 309)
+++ trunk/openjdk/hotspot/make/os2/makefiles/compile.make	(revision 310)
@@ -77,12 +77,11 @@
              -D_POSIX_C_SOURCE=200112 -D_EMX_SOURCE -D_XOPEN_SOURCE=600 \
         	 -D_SVID_SOURCE
-CPP_FLAGS += -I$(ALT_ODINSDK_PATH)/include/Win -I$(ALT_ODINSDK_PATH)/include
+CPP_FLAGS += -I$(ALT_ODINSDK_HEADERS_PATH)/Win -I$(ALT_ODINSDK_HEADERS_PATH)
 
-PRODUCT_LINK_FLAGS      += -L$(ALT_ODINSDK_PATH)/lib/Release -L$(ALT_ODINSDK_PATH)/lib
-FASTDEBUG_LINK_FLAGS    += -L$(ALT_ODINSDK_PATH)/lib/Debug -L$(ALT_ODINSDK_PATH)/lib
-DEBUG_LINK_FLAGS        += -L$(ALT_ODINSDK_PATH)/lib/Debug -L$(ALT_ODINSDK_PATH)/lib
+PRODUCT_LINK_FLAGS      += -L$(ALT_ODINSDK_LIB_PATH)
+FASTDEBUG_LINK_FLAGS    += -L$(firstword $(ALT_ODINSDK_DBGLIB_PATH) $(ALT_ODINSDK_LIB_PATH))
+DEBUG_LINK_FLAGS        += -L$(firstword $(ALT_ODINSDK_DBGLIB_PATH) $(ALT_ODINSDK_LIB_PATH))
 
 LINK_FLAGS  += -lkernel32.lib -luser32.lib -lgdi32.lib -lwinspool.lib \
                -lcomdlg32.lib -ladvapi32.lib -lshell32.lib -lole32.lib \
-               -loleaut32.lib -lWsock32.lib -lwinmm.lib \
-               -llibwrap0.lib -llibwrap1.lib
+               -loleaut32.lib -lWsock32.lib -lwinmm.lib -llibwrap.lib
Index: trunk/openjdk/jdk/make/Makefile
===================================================================
--- trunk/openjdk/jdk/make/Makefile	(revision 309)
+++ trunk/openjdk/jdk/make/Makefile	(revision 310)
@@ -106,5 +106,7 @@
 UNICOWS_DLL_PATH.desc      = Directory containing unicows.dll
 UNICOWS_LIB_PATH.desc      = Directory containing unicows.lib
-ODINSDK_PATH.desc          = Root directory of Odin32 SDK (OS/2)
+ODINSDK_HEADERS_PATH.desc  = Include directory of Odin32 SDK (OS/2)
+ODINSDK_LIB_PATH.desc      = Library directory of Odin32 SDK (OS/2)
+ODINSDK_DBGLIB_PATH.desc   = Debug Library directory of Odin32 SDK (OS/2, optional)
 
 # Make variables to print out (description and value)
@@ -159,8 +161,10 @@
 
 VARIABLE_PRINTVAL_LIST +=       \
-    ODINSDK_PATH
+    ODINSDK_HEADERS_PATH        \
+    ODINSDK_LIB_PATH
 
 VARIABLE_CHECKDIR_LIST +=       \
-    ODINSDK_PATH
+    ODINSDK_HEADERS_PATH        \
+    ODINSDK_LIB_PATH
 
 endif
Index: trunk/openjdk/jdk/make/common/Defs-os2.gmk
===================================================================
--- trunk/openjdk/jdk/make/common/Defs-os2.gmk	(revision 309)
+++ trunk/openjdk/jdk/make/common/Defs-os2.gmk	(revision 310)
@@ -174,12 +174,11 @@
                    -D_POSIX_C_SOURCE=200112 -D_EMX_SOURCE -D_XOPEN_SOURCE=600 \
 				   -D_SVID_SOURCE
-CPPFLAGS_COMMON += -I$(ODINSDK_PATH)/include/Win -I$(ODINSDK_PATH)/include \
+CPPFLAGS_COMMON += -I$(ODINSDK_HEADERS_PATH)/Win -I$(ODINSDK_HEADERS_PATH) \
                    -DWINE_LARGE_INTEGER
 
-LDFLAGS_OPT     += -L$(ODINSDK_PATH)/lib/Release -L$(ODINSDK_PATH)/lib
-LDFLAGS_DBG     += -L$(ODINSDK_PATH)/lib/Debug -L$(ODINSDK_PATH)/lib
+LDFLAGS_OPT     += -L$(ODINSDK_LIB_PATH)
+LDFLAGS_DBG     += -L$(firstword $(ODINSDK_DBGLIB_PATH) $(ODINSDK_LIB_PATH))
 LDFLAGS_COMMON  += -lkernel32.lib -luser32.lib -ladvapi32.lib \
-				   -lminivcrt.lib -lntdll.lib \
-				   -llibwrap0.lib -llibwrap1.lib
+				   -lminivcrt.lib -lntdll.lib -llibwrap.lib
 
 #
Index: trunk/openjdk/jdk/make/common/shared/Defs-os2.gmk
===================================================================
--- trunk/openjdk/jdk/make/common/shared/Defs-os2.gmk	(revision 309)
+++ trunk/openjdk/jdk/make/common/shared/Defs-os2.gmk	(revision 310)
@@ -142,11 +142,27 @@
 endif
 
-# ODINSDK_PATH: Path to the root directory of Odin32 SDK
-ifdef ALT_ODINSDK_PATH
-  xALT_ODINSDK_PATH :="$(subst \,/,$(ALT_ODINSDK_PATH))"
-  ODINSDK_PATH      :=$(call FullPath,$(xALT_ODINSDK_PATH))
-endif
-ODINSDK_PATH :=$(call AltCheckSpaces,ODINSDK_PATH)
-ODINSDK_PATH :=$(call AltCheckValue,ODINSDK_PATH)
+# ODINSDK_HEADERS_PATH: Include directory of Odin32 SDK (OS/2)
+ifdef ALT_ODINSDK_HEADERS_PATH
+  xALT_ODINSDK_HEADERS_PATH :="$(subst \,/,$(ALT_ODINSDK_HEADERS_PATH))"
+  ODINSDK_HEADERS_PATH      :=$(call FullPath,$(xALT_ODINSDK_HEADERS_PATH))
+endif
+ODINSDK_HEADERS_PATH :=$(call AltCheckSpaces,ODINSDK_HEADERS_PATH)
+ODINSDK_HEADERS_PATH :=$(call AltCheckValue,ODINSDK_HEADERS_PATH)
+
+# ODINSDK_LIB_PATH: Library directory of Odin32 SDK (OS/2)
+ifdef ALT_ODINSDK_LIB_PATH
+  xALT_ODINSDK_LIB_PATH :="$(subst \,/,$(ALT_ODINSDK_LIB_PATH))"
+  ODINSDK_LIB_PATH      :=$(call FullPath,$(xALT_ODINSDK_LIB_PATH))
+endif
+ODINSDK_LIB_PATH :=$(call AltCheckSpaces,ODINSDK_LIB_PATH)
+ODINSDK_LIB_PATH :=$(call AltCheckValue,ODINSDK_LIB_PATH)
+
+# ODINSDK_DBGLIB_PATH: Debug Library directory of Odin32 SDK (OS/2)
+ifdef ALT_ODINSDK_DBGLIB_PATH
+  xALT_ODINSDK_DBGLIB_PATH :="$(subst \,/,$(ALT_ODINSDK_DBGLIB_PATH))"
+  ODINSDK_DBGLIB_PATH      :=$(call FullPath,$(xALT_ODINSDK_DBGLIB_PATH))
+endif
+ODINSDK_DBGLIB_PATH :=$(call AltCheckSpaces,ODINSDK_DBGLIB_PATH)
+ODINSDK_DBGLIB_PATH :=$(call AltCheckValue,ODINSDK_DBGLIB_PATH)
 
 # Import JDK images allow for partial builds, components not built are
Index: trunk/openjdk/jdk/make/common/shared/Sanity-Settings.gmk
===================================================================
--- trunk/openjdk/jdk/make/common/shared/Sanity-Settings.gmk	(revision 309)
+++ trunk/openjdk/jdk/make/common/shared/Sanity-Settings.gmk	(revision 310)
@@ -234,5 +234,7 @@
 endif
 ifeq ($(PLATFORM),os2)
-  ALL_SETTINGS+=$(call addAltSetting,ODINSDK_PATH)
+  ALL_SETTINGS+=$(call addAltSetting,ODINSDK_HEADERS_PATH)
+  ALL_SETTINGS+=$(call addAltSetting,ODINSDK_LIB_PATH)
+  ALL_SETTINGS+=$(call addAltSetting,ODINSDK_DBGLIB_PATH)
 endif
 ALL_SETTINGS+=$(call addAltSetting,CACERTS_FILE)
Index: trunk/openjdk/jdk/make/common/shared/Sanity.gmk
===================================================================
--- trunk/openjdk/jdk/make/common/shared/Sanity.gmk	(revision 309)
+++ trunk/openjdk/jdk/make/common/shared/Sanity.gmk	(revision 310)
@@ -1312,20 +1312,18 @@
 sane-odinsdk:
 ifeq ($(PLATFORM), os2)
-	@if [ ! -r $(ODINSDK_PATH)/include/odin.h  ]; then \
+	@if [ ! -r $(ODINSDK_HEADERS_PATH)/odin.h  ]; then \
 	$(ECHO) "ERROR: You do not have access to a valid Odin32 SDK include dir.\n" \
-	  "      The value of ODINSDK_PATH must point a valid Odin32 SDK dir.\n" \
+	  "      The value of ODINSDK_HEADERS_PATH must point a valid Odin32 SDK dir.\n" \
 	  "      Please check your access to \n" \
-	  "          $(ODINSDK_PATH)/include \n" \
-	  "      and/or check your value of ALT_ODINSDK_PATH.\n" \
+	  "          $(ODINSDK_HEADERS_PATH) \n" \
+	  "      and/or check your value of ALT_ODINSDK_HEADERS_PATH.\n" \
 	  "" >> $(ERROR_FILE) ; \
 	fi
-	@if [ ! -r $(ODINSDK_PATH)/lib/odincrt.lib -a \
-	      ! -r $(ODINSDK_PATH)/lib/Release/odincrt.lib ]; then \
+	@if [ ! -r $(ODINSDK_LIB_PATH)/odincrt.lib ]; then \
 	$(ECHO) "ERROR: You do not have access to a valid Odin32 SDK lib dir.\n" \
-	  "      The value of ODINSDK_PATH must point a valid Odin32 SDK dir.\n" \
+	  "      The value of ODINSDK_LIB_PATH must point a valid Odin32 SDK dir.\n" \
 	  "      Please check your access to \n" \
-	  "          $(ODINSDK_PATH)/lib          or \n" \
-	  "          $(ODINSDK_PATH)/lib/Release \n" \
-	  "      and/or check your value of ALT_ODINSDK_PATH.\n" \
+	  "          $(ODINSDK_LIB_PATH)/lib \n" \
+	  "      and/or check your value of ALT_ODINSDK_LIB_PATH.\n" \
 	  "" >> $(ERROR_FILE) ; \
 	fi