Index: /trunk/openjdk/hotspot/src/cpu/x86/vm/jni_x86.h
===================================================================
--- /trunk/openjdk/hotspot/src/cpu/x86/vm/jni_x86.h	(revision 314)
+++ /trunk/openjdk/hotspot/src/cpu/x86/vm/jni_x86.h	(revision 315)
@@ -46,5 +46,5 @@
 
   typedef int jint;
-#ifdef __EMX__
+#ifdef TARGET_COMPILER_gcc
   typedef __int64_t jlong;
 #else
Index: /trunk/openjdk/hotspot/src/os/os2/vm/os_os2_init.cpp
===================================================================
--- /trunk/openjdk/hotspot/src/os/os2/vm/os_os2_init.cpp	(revision 314)
+++ /trunk/openjdk/hotspot/src/os/os2/vm/os_os2_init.cpp	(revision 315)
@@ -33,5 +33,5 @@
 
 #include <types.h>
-#ifdef __EMX__
+#ifdef TARGET_COMPILER_gcc
 #include <emx/startup.h>
 #endif
@@ -58,5 +58,5 @@
     switch (ulFlag) {
     case 0 :
-#ifdef __EMX__
+#ifdef TARGET_COMPILER_gcc
         // initialize the C library
         if (_CRT_init())
@@ -85,5 +85,5 @@
           UnregisterLxDll(dllHandle);
         }
-#ifdef __EMX__
+#ifdef TARGET_COMPILER_gcc
         // destroy C++ statics
         __ctordtorTerm();
Index: /trunk/openjdk/hotspot/src/os/windows/vm/attachListener_windows.cpp
===================================================================
--- /trunk/openjdk/hotspot/src/os/windows/vm/attachListener_windows.cpp	(revision 314)
+++ /trunk/openjdk/hotspot/src/os/windows/vm/attachListener_windows.cpp	(revision 315)
@@ -151,5 +151,5 @@
 
  public:
-#ifdef __EMX__
+#ifdef TARGET_COMPILER_gcc
   void complete(jint result, bufferedStream* result_stream);
 #else
Index: /trunk/openjdk/hotspot/src/os/windows/vm/os_windows.cpp
===================================================================
--- /trunk/openjdk/hotspot/src/os/windows/vm/os_windows.cpp	(revision 314)
+++ /trunk/openjdk/hotspot/src/os/windows/vm/os_windows.cpp	(revision 315)
@@ -3499,5 +3499,5 @@
   void *code_ptr = (void *)code;
   __try {
-#ifdef __EMX__
+#ifdef TARGET_COMPILER_gcc
     __asm__("call *%0" : : "m"(code_ptr));
 #else
@@ -3606,5 +3606,5 @@
 #ifndef  _WIN64
     static long fp_control_word = 0;
-#ifdef __EMX__
+#ifdef TARGET_COMPILER_gcc
     __asm__("fstcw %0" : "=m"(fp_control_word));
 #else
@@ -3619,5 +3619,5 @@
     const long invalid   = 0x01;
     fp_control_word |= invalid;
-#ifdef __EMX__
+#ifdef TARGET_COMPILER_gcc
     __asm__("fldcw %0" : : "m"(fp_control_word));
 #else
Index: /trunk/openjdk/hotspot/src/os/windows/vm/os_windows.inline.hpp
===================================================================
--- /trunk/openjdk/hotspot/src/os/windows/vm/os_windows.inline.hpp	(revision 314)
+++ /trunk/openjdk/hotspot/src/os/windows/vm/os_windows.inline.hpp	(revision 315)
@@ -43,5 +43,5 @@
 inline const char* os::dll_file_extension()            { return ".dll"; }
 
-#ifdef __EMX__
+#ifdef TARGET_COMPILER_gcc
 inline const char* os::jlong_format_specifier()        { return "%lld"; }
 inline const char* os::julong_format_specifier()       { return "%llu"; }
Index: /trunk/openjdk/hotspot/src/os_cpu/windows_x86/vm/os_windows_x86.cpp
===================================================================
--- /trunk/openjdk/hotspot/src/os_cpu/windows_x86/vm/os_windows_x86.cpp	(revision 314)
+++ /trunk/openjdk/hotspot/src/os_cpu/windows_x86/vm/os_windows_x86.cpp	(revision 315)
@@ -93,5 +93,5 @@
     if ( ThreadLocalStorage::get_thread_ptr_offset() == 0 ) {
       int thread_ptr_offset;
-#ifdef __EMX__
+#ifdef TARGET_COMPILER_gcc
       __asm__("leal %1, %%eax; "
               "subl %%fs:0, %%eax; "
@@ -113,5 +113,5 @@
     else {
       int test_thread_ptr_offset;
-#ifdef __EMX__
+#ifdef TARGET_COMPILER_gcc
       __asm__("leal %1, %%eax; "
               "subl %%fs:0, %%eax; "
@@ -389,5 +389,5 @@
 intptr_t* _get_previous_fp() {
   intptr_t **frameptr;
-#ifdef __EMX__
+#ifdef TARGET_COMPILER_gcc
   __asm("movl %%ebp, %0" : "=m"(frameptr));
 #else
@@ -551,5 +551,5 @@
    // On systems that don't support pause a rep:nop
    // is executed as a nop.  The rep: prefix is ignored.
-#ifdef __EMX__
+#ifdef TARGET_COMPILER_gcc
    __asm__("pause; ");
 #else
@@ -566,5 +566,5 @@
 #ifndef AMD64
   int fpu_cntrl_word = StubRoutines::fpu_cntrl_wrd_std();
-#ifdef __EMX__
+#ifdef TARGET_COMPILER_gcc
   __asm__("fldcw %0; " : : "m"(fpu_cntrl_word));
 #else  
Index: /trunk/openjdk/hotspot/src/share/vm/utilities/globalDefinitions.hpp
===================================================================
--- /trunk/openjdk/hotspot/src/share/vm/utilities/globalDefinitions.hpp	(revision 314)
+++ /trunk/openjdk/hotspot/src/share/vm/utilities/globalDefinitions.hpp	(revision 315)
@@ -240,5 +240,5 @@
 inline address_word  castable_address(void* x)                { return address_word(x) ; }
 
-#ifdef __EMX__
+#ifdef TARGET_COMPILER_gcc
 // GCC 4.4.4 forbids implicit cast from function pointers to void*
 template <class T>